package com.guozhi.elasticsearch;

import cn.hutool.core.io.FileUtil;
import com.alibaba.druid.util.Base64;
import com.alibaba.fastjson.JSON;
import org.frameworkset.elasticsearch.ElasticSearchHelper;
import org.frameworkset.elasticsearch.boot.BBossESStarter;
import org.frameworkset.elasticsearch.client.ClientInterface;
import org.frameworkset.elasticsearch.client.ClientOptions;
import org.frameworkset.elasticsearch.entity.ESDatas;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import sun.rmi.runtime.Log;

import javax.annotation.Resource;
import java.io.File;
import java.util.HashMap;
import java.util.Map;

/**
 * @author LiuchangLan
 * @date 2020/10/21 17:11
 */
@SpringBootTest
public class DocDemo {

    @Resource
    private BBossESStarter bbossESStarter;

    @Test
    void test(){
//        createDoc("demo","demo");

//        delete("demo","demo","1");

        insertFile();
//        select();
    }

    /**
     * @description 添加\修改一条数据 id相同则修改
     * @author LiuChangLan
     * @since 2020/10/21 17:20
     */
    void createDoc(String indice,String docName){
        Map<String,Object> param = new HashMap<String, Object>();
        ClientOptions clientOptions = new ClientOptions();
        // id字段
        clientOptions.setIdField("id");
        // 是否刷新
        clientOptions.setRefresh("true");
        param.put("id",1);
        param.put("name","张三");
        param.put("age",16);
        String s = bbossESStarter.getRestClient().addDocument(indice, docName, param, clientOptions);
    }

    /**
     * @description 删除文档
     * @author LiuChangLan
     * @since 2020/10/22 9:36
     */
    void delete(String indice,String docName,String id){
        bbossESStarter.getRestClient().deleteDocument(indice,docName,id);
    }

    /**
     * @description es查询
     * @author LiuChangLan
     * @since 2020/10/22 9:36
     */
    void select(){
        ClientInterface restClient = ElasticSearchHelper.getConfigRestClientUtil("elasticsearch/demo.xml");
        ESDatas<Map> mapESDatas = restClient.searchList("archives/_search", "query", null, Map.class);
        System.out.println(JSON.toJSONString(mapESDatas));
    }

    void insertFile(){
        File file = new File("C:\\Users\\84731\\Desktop\\面试资料\\后端面试题\\说说volatile关键字 .pdf");
        // 获取文件字节数组
        byte[] bytes = FileUtil.readBytes(file);
        // 转成base64
        String sa = Base64.byteArrayToBase64(bytes);
        // 参数
        Map<String,Object> param = new HashMap<String, Object>();
        // 配置
        ClientOptions clientOptions = new ClientOptions();
        // id字段
        clientOptions.setIdField("id");
        // 是否刷新
        clientOptions.setRefresh("true");
        param.put("id",3);
        param.put("filename","aaa");
        param.put("data",sa);
        // 设置处理管道
        clientOptions.setPipeline("attachment");

        System.out.println("配置完成，发起请求");
        String s = bbossESStarter.getRestClient().addDocument("file_index_test", "", param, clientOptions);
        System.out.println("请求结束，插入完成");
    }
}
