package com.guozhi.elasticsearch;

import org.frameworkset.elasticsearch.boot.BBossESStarter;
import org.frameworkset.elasticsearch.client.ClientInterface;
import org.frameworkset.spi.annotations.Autowired;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

/**
 * @author LiuchangLan
 * @date 2020/10/21 16:46
 */
@SpringBootTest
public class InstanceDemo {

    @Resource
    private BBossESStarter bbossESStarter;

    @Test
    void test(){
        this.createIndice("demo");
//        this.dropIndice("ceshi");
//        System.out.println(this.existsIndice("ceshi"));
    }


    /**
     * @description 创建索引
     * @author LiuChangLan
     * @since 2020/10/21 16:52
     * @param indiceName 索引名称
     */
    void createIndice(String indiceName){
      bbossESStarter.getRestClient().createIndiceMapping(indiceName,"");
    }

    /**
     * @description 索引是否存在
     * @author LiuChangLan
     * @since 2020/10/21 16:54
     * @param indiceName 索引名
     */
    boolean existsIndice(String indiceName){
        return bbossESStarter.getRestClient().existIndice(indiceName);
    }

    /**
     * @description 删除索引
     * @author LiuChangLan
     * @since 2020/10/21 16:55
     * @param indiceName 索引名
     */
    void dropIndice(String indiceName){
        bbossESStarter.getRestClient().dropIndice(indiceName);
    }

}
